import os, re, string, sys

class testobj:
	def __init__(self, name, source_url, build_command, install_command, 
		     test_dir, log_dir, run_command):
		self.name = name
		self.source_url = source_url
		self.build_command = build_command
		self.install_command = install_command
		self.test_dir = test_dir
		self.log_dir = log_dir
		self.run_command = run_command
	def install(self):
		os.system("wget -c "+self.source_url)
		#Now it handles both tar.gz(tgz) and tar.bz2 file
		source_filename = string.split(self.source_url,'/')[-1]
		if re.search(".tar.gz$", source_filename) or re.search(".tgz$", source_filename): 
			os.system("tar -xvzf "+source_filename)
		elif re.search(".bz2$", source_filename):
			os.system("tar -xvjf "+source_filename)
		else: 
			print "Can not uncompress file:", source_filename
			sys.exit() 	
		os.chdir(self.test_dir)
		os.system(self.build_command)
		os.system(self.install_command)
		os.chdir("..")
	def run(self):
		#I added this for creating the non-exist log dir.
		if not os.path.exists(self.log_dir):
        	        print "log_dir",self.log_dir,"does not exists. Creating it..."
	                os.system("mkdir -p "+self.log_dir)
		os.chdir(self.test_dir)
		os.system(self.run_command)
